Next Previous Contents

2. Getting and installing AfterStep

2.1 Where do I get AfterStep?

The main AfterStep resources on the net are below.

2.2 What is the latest version of AfterStep?

The latest official version is 1.4.5, released in April 1998. A development release,, was widely considered to be a true stable release; it has, in fact, fewer bugs than 1.4.5.

Version 1.5.0 should be available by the time you read this. If you are contemplating installing a version of AfterStep, it is worth either waiting for the release of version 1.5.0, or installing the latest beta version of 1.5. Any version of the 1.5 series is a significant improvement over any 1.4.x release.

There is also a current development effort around the old version of AfterStep (v. 1.0). This effort is called AfterStepClassic. It is primarily directed towards fixing bugs in the old 1.0 release of AfterStep, and is not always compatible with new developments in AfterStep. It uses only the .steprc-style configuration, so if you are looking for information on how to configure AfterStepClassic, you should assume that the information about versions < 1.2 apply to you. The lead developer for AfterStepClassic is Stephen Ma (

2.3 What do I need to install AfterStep?

AfterStep is an X window manager. So, you need to have an X workstation. It will apparently compile against, and work with, X11R5, but for optimal performance, it is preferable that you use X11R6. In order to compile AfterStep from the source, you need (apart from a C compiler, like gcc) the X developers' libraries on your system. The most common problem that people have in compiling AfterStep is as a result of not having the required libraries on their system. In particular, XFree86 lists the necessary libraries as an "optional" package. As a result, many people do not install them, and so cannot compile AfterStep. You should be able to get the libraries wherever you got your distribution of XFree86.

AfterStep is known to run on Linux, FreeBSD (not all modules work), HP-UX, and Solaris. For the latter two, you should read the relevant READMEs before trying to compile.

X, and hence AfterStep, is really designed with an eye to the assumptions of multiuser systems like UNIX or VMS. If you are using X on some other platform, and particularly, if you are trying to run X atop any version of Windows, you will have to do much of the porting work yourself. There is a link above offering advice on getting AfterStep to work under Windows; but this practice is not encouraged. You are likely to get greater ease of use by using LiteSTEP.

2.4 I receive the message: Cannot open display. What should I do?

AfterStep is an X window manager and cannot be run from the terminal. It must be run through X. The easiest way to do that is to create (or edit) your own .xinitrc file (which contains a list of the programs you wish to load upon startup) and to add the line exec afterstep to the end. This last exec'd line is significant in that it says to shut down X when that program is terminated. Now that you have that file, simply startup X in your customary manner (most likely by issuing "startx" or "xinit"). Now you're off and running. Good luck!

If you are using xdm, you will need to put the call to afterstep in your .xsessions file.

2.5 How can I install AfterStep without being root?

This is fairly easy, but you must be sensitive to the version you are using.

You will have to install all the files under your home directory. The usual recommendation is to use the same directories as suggested in the installation procedure, but replacing /usr/share, usr/local, or whatever you like by your home directory. For example, if you home directory is /home/blah you would use directories like /home/blah/bin, /home/blah/etc, /home/blah/lib, and the like.

Compile AfterStep following the standard installation procedure (i.e the one described in the README) until the install step. Then, do the following (make sure to create the destination directories first if they don't exist. All the source paths are relative to the AfterStep source directory):

  1. Copy afterstep/afterstep to $HOME/bin/.
  2. Copy modules/*/(binaries) to $HOME/bin/.
  3. Copy apps/*/(binaries) to $HOME/bin/.
  4. Copy GNUstep/ to $HOME/.
  5. Edit $HOME/GNUstep/Library/AfterStep/base.* to reflect the above paths in the lines starting with ModulePath and PixmapPath.
  6. Put $HOME/bin in your path.

You should be set. Feel free to modify this procedure according to your particular needs or the particular setup of your machine/account.

You should note that, during the 1.4.5.x series, the source paths changed. If the changes are not transparent to you, you should probably move to the 1.5 series anyway. The 1.5 series includes an install script that allows you to set the install directories to whatever you want. Even though the instructions say you should have root access, you can install AS under your home directory. The trick here is to specify only directories to which you have write permissions. Importantly, you must specify the full path on most systems. Otherwise, there is a good chance that something will not read correctly; this will affect your installation of AfterStep. On some systems, you may also have to add the new subdirectories to your ".profile", ".cshrc", ".xsessions", or other such file. If you don't know what this means, you should either contact your system administrator, or read a good book about your operating system or X windowing system.

2.6 Why do I keep getting compile errors?

The most common reason for problems compiling is that you do not have all the necessary libraries and headers available on your system. This often happens to people who have recently upgraded their distribution of XFree86. The necessary libraries are included in an "optional" file which matches the version of XFree86 in question; the most recent of these is X332prog.tgz (for XFree86 3.3.2). You should be able to find the file you need wherever you obtained your distribution of X.

2.7 Why do I keep getting an error referring to sgmltools?

This FAQ file is maintained in SGML according to the Linuxdoc DTD; some version of the FAQ is included with every AfterStep distribution. In order to make it easily readable, a program called sgml2html (part of sgmltools) converts the file to HTML. A script, afterstepdoc (by default, the first button on the Wharf), should open a browser and allow you to read the FAQ. Unfortunately, not everyone has sgmltools; and even if they are installed, they are not detected correctly at install time. As a result, the HTML version of the FAQ is now shipped with the latest versions of AfterStep. The SGML source is still included with the AfterStep source, however, so if you want other versions of this FAQ -- dvi, PostScript, or even plain text -- just use the sgmltools package to convert the SGML source to whatever format you like.

2.8 Why can't I get AfterStep to compile on SGI or SCO?

The problem here was tracked down and reported by Benjamin J. Tracy ( and (independently) John Koch ( The ordering of the libraries in the link command is wrong. Just make sure that the afterstep library appears before the -lX11 argument on the link command line (in the Makefile). Everything should work after that.

2.9 Will AfterStep compile correctly on FreeBSD?

AfterStep itself works fine on FreeBSD, but some as-apps will not work. In particular, there are some that depend upon a Linux-type /proc filesystem. That filesystem is very different on BSD-type system.

Next Previous Contents